var flickrResponse = "";
var apiKey = "";
var apiKeyTest = "8fc4ec167bb1d1043ef4a4c942ccf3a9";
var apiMethod = "flickr.people.getPublicPhotos";
var userId = "";
var username = "tompagenet";


var totalDisplay = 4;
var totalColumns = 4;

class UserSettings extends React.Component {
    
    constructor(props) {
        super(props);
        this.state = {usernameEntered: username, numberEntered: totalDisplay, submitDisabled: false };
    
        this.handleChange = this.handleChange.bind(this);
        this.handleNumChange = this.handleNumChange.bind(this);
        this.handleSubmit = this.handleSubmit.bind(this);
      }
    
      handleChange(event) {
        this.setState({usernameEntered: event.target.value});
      }

      handleNumChange(event) {
        this.setState({numberEntered: event.target.value});
      }
    
      handleSubmit(event) {
        /*this.setState({submitDisabled: true});*/
        this.props.onChange(true);
        username=this.state.usernameEntered;
        totalDisplay = this.state.numberEntered;
        event.preventDefault();
        userId = getFlickrNsid(username);
        startFlickr();
      }

      render() {
        return (
            <form onSubmit={this.handleSubmit}>
                <label>
                    Flickr user ID: 
                    <input id="flickrUserIdInput" name="flickrUserIdInput" type='text' value={this.state.usernameEntered} onChange={this.handleChange}/>
                </label>
                <br />
                <label>
                    Photos to fetch: 
                    <input type='number' value={this.state.numberEntered} onChange={this.handleNumChange} min={1} max={100}/>
                </label>
                <input type="submit" value={"Fetch " + this.state.numberEntered + " " + makePlural("photo", this.state.numberEntered)} disabled={this.state.submitDisabled} />
                <label>
                    Wait a while once the button is pressed
                </label>
            </form>
      );
    }
}

class OverallForm extends React.Component {
    constructor(props) {
        super(props);
        this.state = { formVisible: true };
        this.formChange = this.formChange.bind(this);
      }
    
    formChange(newState) {
        this.setState({
          formVisible: !newState
        });
      }
    
    render() {
        return(
            <div>
                {this.state.formVisible ? <UserSettings onChange={this.formChange} /> : null}
            </div>
        );
    }
}

ReactDOM.render(<OverallForm />,document.getElementById('form'));

function makePlural (singular, n) {
    return ((n>1) ? singular + "s" : singular);

}

function objToString (obj) {
    var str = '';
    for (var p in obj) {
        if (obj.hasOwnProperty(p)) {
            str += p + '::' + obj[p] + '\n';
        }
    }
    return str;
}

class TitleWrite extends React.Component {
    render() {
        return (
            <div>
                <h1>{totalDisplay} random images from {username}'s Flickr</h1>
                <p>Total photos {this.props.totalImages}. Selected {this.props.chosenString}</p>
            </div>
    );
    }
}

class FlickrImage extends React.Component {
    render() {
    let photoArray = this.props.photoArray;
    let photoURL="https://farm" + photoArray[this.props.flickrIndex][0]["farm"] + ".staticflickr.com/" + photoArray[this.props.flickrIndex][0]["server"] + "/" + photoArray[this.props.flickrIndex][0]["id"] + "_" + photoArray[this.props.flickrIndex][0]["secret"] + ".jpg";
    let photoPageURL="https://www.flickr.com/photos/" + photoArray[this.props.flickrIndex][0]["owner"] + "/" + photoArray[this.props.flickrIndex][0]["id"];
    return (
            <a href={photoPageURL} key={photoArray[this.props.flickrIndex][0]["id"]}><img src={photoURL} key={photoArray[this.props.flickrIndex][0]["id"]}/></a>
    );
    }
}

class MakeColumn extends React.Component {
    render() {
        console.log("MakeColumn writing column " + this.props.colNum);
        return (
            <div className="column" style={this.props.columnStyle}>
                    {this.props.arrayPassed}
            </div>
    );
    }

}

class MainPage extends React.Component {
    constructor(props) {
    super(props);
    this.state = { completedImages: 0 };
    }
    
    
    render() {
    var allImages=[];
        for (var i=0; i < totalDisplay; i++){
        allImages.push(<FlickrImage flickrIndex={i} photoArray={this.props.photoArray} />);
        this.state.completedImages++ ;
        }

    console.log("Total entries in allImages = " + allImages.length);

    var remainingImages=allImages;

    console.log("Total entries in remainingImages = " + remainingImages.length);


    var tempArray = [];
    var imagesPerColumn = Math.ceil(totalDisplay/totalColumns);
    var outputArray = [];
    var imagesProcessed = 0;

    console.log("About to start column production with " + totalColumns + " columns and " + imagesPerColumn + " images per column");

    for (var i=0; i < totalColumns; i++){
        for (var j=0; j < imagesPerColumn; j++) {
            console.log("i = " + i + " j = " + j + " array index: " + (i*imagesPerColumn + j));
            if(imagesProcessed != totalDisplay){
            console.log("tempArray length is " + tempArray.length);
            tempArray.push(remainingImages[i*imagesPerColumn + j]);
            imagesProcessed++;
            console.log("tempArray length: " + tempArray.length + " imagesProcessed: " + imagesProcessed);
            }
        
        }
        console.log("Calling MakeColumn for colNum " + i);
        outputArray.push(<MakeColumn colNum={i} arrayPassed={tempArray} columnStyle={this.props.columnStyle} key={i.toString()}/>);
        tempArray=[];

    }
    
        return (
        <div>
            {(this.state.completedImages == totalDisplay) ? null : <p>Processed {this.state.completedImages} images</p>}
            <div className="row">
                {outputArray}
            </div>
        </div>
    );
    }
}

function getFlickrNsid(username){
    var xhr = new XMLHttpRequest();
    
    var apiMethodUser = "flickr.people.findByUsername";
    var apiIndexCallUser = "https://api.flickr.com/services/rest/?method=" + apiMethodUser + "&api_key=" + apiKeyTest + "&username=" + username + "&format=json&nojsoncallback=1";
    
    xhr.open("GET", apiIndexCallUser, false);
    xhr.send();

    var userResponse = JSON.parse(xhr.response);
    var userNsid = userResponse["user"]["nsid"];
    return userNsid;
}



function startFlickr () {

    var apiIndexCall = "https://api.flickr.com/services/rest/?method=" + apiMethod + "&api_key=" + apiKeyTest + "&user_id="+userId + "&per_page=1" + "&format=json&nojsoncallback=1";
    var xhr = new XMLHttpRequest();
    xhr.open("GET", apiIndexCall, false);
    xhr.send();
    var flickrArray = JSON.parse(xhr.response);
    var totalImages = flickrArray["photos"]["total"];
    var chosenIndex = [];

    var chosenString = "";

    for (var i=0; i<totalDisplay; i++){
        chosenIndex[i]=Math.floor((Math.random() * totalImages) + 1);
    }

    chosenIndex.sort(function(a, b){return a-b});

    for (var i=0; i<totalDisplay; i++){
        chosenString = chosenString + ((chosenString.length != 0) ? ((i != (totalDisplay-1)) ? ", " : " & ") : "") + Intl.NumberFormat().format(chosenIndex[i]);
    }

    ReactDOM.render(<TitleWrite totalImages={totalImages} chosenString={chosenString}/>,document.getElementById('title'));

    {/*Specific photo*/}
    var apiPhotoCall = "";
    var photoArray=[];
    var columnStyle = { width: 'calc(' + 100/totalColumns + '% - 10px)' } ;

    for (var i=0; i<totalDisplay; i++){

        apiPhotoCall = "https://api.flickr.com/services/rest/?method=" + apiMethod + "&api_key=" + apiKeyTest + "&user_id="+userId + "&format=json&nojsoncallback=1" + "&per_page=1&page=" + chosenIndex[i];
        xhr.open("GET", apiPhotoCall, false);
        xhr.send();
        flickrArray = JSON.parse(xhr.response);
        photoArray[i] = flickrArray["photos"]["photo"];
    }

    
    ReactDOM.render(<MainPage columnStyle={columnStyle} photoArray={photoArray} />,document.getElementById('root'));

}